#define version 3.0
%define cvsdate 20050505.142624
%define version 0.0.%(echo %{cvsdate}|awk -F. '{print $1}')
%define release 0.1.cvs

Summary:      Object oriented programming environment for real-time audio and video processing
Name:         supercollider
Version:      %{version}
Release:      %{release}
License:      GPL
Group:        Applications/Multimedia
URL:          http://supercollider.sourceforge.net/
Source0:      SuperCollider3-3.0%{?cvsdate:-cvs}.tar.gz
Source1:      supercollider-get-cvs
Patch0:       supercollider3-3.0-buildmakefile.patch
BuildRoot:    %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Requires:     emacs
Packager:     Fernando Lopez-Lezcano
Vendor: Planet CCRMA
Distribution: Planet CCRMA

BuildRequires: gcc-c++, autoconf, automake, libtool, pkgconfig
BuildRequires: jack-audio-connection-kit-devel, libsndfile-devel, alsa-lib-devel
BuildRequires: emacs, openmotif-devel, XFree86-devel
%{?fc3:BuildRequires: howl-devel}

%description
SuperCollider is an object oriented programming environment for
real-time audio and video processing. It is one of the finest and most
versatile environments for signal processing and especially for
creating music applications of all kinds, such as complete
compositions, interactive performances, installations etc.

%prep
%setup -q -n SuperCollider3-3.0
%patch0 -p1

%build
# point the default location of help to the shared install
%{__perl} -p -i -e "s|~/SuperCollider/Help|%{_datadir}/SuperCollider/Help|g" linux/scel/el/sclang-help.el

./linux/bootstrap
# get the correct directory for linking with X
%{__perl} -p -i -e "s|-lX11|-L/usr/X11R6/lib -lX11|g" configure
# get the correct include directory for howl, sc should use pkgconfig
%{__perl} -p -i -e "s|howl/howl.h|howl-0.9.6/howl.h|g" source/server/Rendezvous.cpp
%configure
%{__make} %{?_smp_mflags}

%install
%{__rm} -rf %{buildroot}
%{__make} DESTDIR=%{buildroot} install

# install the Help and Tutorial files
(cd build; %{__tar} cf - Help)| (cd %{buildroot}%{_datadir}/SuperCollider; %{__tar} xpf -)

# install default per-user configuration files
%{__mkdir} -p %{buildroot}%{_datadir}/SuperCollider/configuration
%{__cp} -p linux/examples/sclang.cfg %{buildroot}%{_datadir}/SuperCollider/configuration
%{__cp} -p linux/examples/sclang.sc  %{buildroot}%{_datadir}/SuperCollider/configuration

# install sclang.cfg to /etc
%{__mkdir} -p %{buildroot}%{_sysconfdir}
%{__install} -m0644 linux/examples/sclang.cfg %{buildroot}%{_sysconfdir}/sclang.cfg
# add proper full paths to the configuration file
%{__perl} -p -i -e "s|\+/Linux|\+%{_datadir}/SuperCollider/Extensions|g" %{buildroot}%{_sysconfdir}/sclang.cfg
%{__perl} -p -i -e "s|\+/Common|\+%{_datadir}/SuperCollider/SCClassLibrary/Common|g" %{buildroot}%{_sysconfdir}/sclang.cfg
%{__perl} -p -i -e "s|\+/DefaultLibrary|\+%{_datadir}/SuperCollider/SCClassLibrary/DefaultLibrary|g" %{buildroot}%{_sysconfdir}/sclang.cfg
%{__perl} -p -i -e "s|\+/backwards_compatibility|\+%{_datadir}/SuperCollider/SCClassLibrary/backwards_compatibility|g" %{buildroot}%{_sysconfdir}/sclang.cfg

# add sclang and scsynth shared library links
%{__ln_s} -f libsclang.so.0.0.0 %{buildroot}%{_libdir}/libsclang.so.0
%{__ln_s} -f libscsynth.so.0.0.0 %{buildroot}%{_libdir}/libscsynth.so.0
%{__ln_s} -f libsclang.so.0.0.0 %{buildroot}%{_libdir}/libsclang.so
%{__ln_s} -f libscsynth.so.0.0.0 %{buildroot}%{_libdir}/libscsynth.so

%clean
%{__rm} -rf %{buildroot}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc changes.rtf COPYING doc/*.rtf linux/README linux/NEWS
%{_bindir}/*
%{_includedir}/supercollider
%{_libdir}/SuperCollider
%{_libdir}/*.a
%exclude %{_libdir}/*.la
%{_libdir}/*.so*
%{_libdir}/pkgconfig/*
%{_datadir}/SuperCollider
%{_datadir}/emacs/site-lisp/*
%config %{_sysconfdir}/sclang.cfg

%changelog
* Thu May  5 2005 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20050505
- updated to cvs snapshot 2005.05.05
- added howl-devel build requirement on fc3
- create proper configuration file
- do not add ~/supercollider directory, users will need to create the
  proper subdirectories in the current directory before starting sclang
* Sun Oct  3 2004 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20040930
- tried to --enable-lid but compile fails
* Thu Sep 30 2004 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 0.0.20040930
- cvs: 2004/09/30
- added patch to configure to add X11 library path search
* Fri Aug 13 2004 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 2004.08.13-1
- downloaded new cvs snapshot
- many changes to spec file
- add .so.0 links for sclang and scsynth shared libraries
* Wed Jan 21 2004 Fernando Lopez-Lezcano <nando@ccrma.Stanford.EDU> 3.0-1.cvs
- Initial build.
- installs a /root/.sclang.cfg??
